#!/usr/bin/env perl
#!/bin/env perl

## Name: addXS.pl
## Version: 1.2.1
## Date: Mar 09, 2016
## Author: Van Du Tran and Daniel Gautheret
## Maintainer: Van Du Tran and Daniel Gautheret

## add XS to mate in case another mate is XS-defined
# --input, input sam file
# --output, output sam file

use strict;
use warnings;
use Getopt::Long;

my $help;
my $input;
my $output;

my $line1;
my $line2;
my $xs;
my @args;

usage() if (@ARGV < 2 or
	    ! GetOptions("help|?" => \$help,
			 "input=s" => \$input,
			 "output=s" => \$output)
	    or defined $help);

if (defined $input) {
    open(STDIN, $input);
}
if (defined $output) {
    open(STDOUT, ">$output");
}

while ($line1 = <STDIN>) {
    chomp($line1);
    @args = split("\t", $line1);
    if ($args[0] eq "\@HD" || $args[0] eq "\@SQ" || $args[0] eq "\@PG") {
        print STDOUT "$line1\n";
    }
    else {
        last;
    }
}
if ($line1) {
    chomp($line1);
}
while ($line2 = <STDIN>) {
    chomp($line2);
    if (index($line1, "XS:A")!=-1 && index($line2, "XS:A")==-1) {
	print STDOUT "$line1\n";
	$xs = substr($line1, index($line1, "XS:A"), 6);
	print STDOUT "$line2\t$xs\n";
    }
    elsif (index($line1, "XS:A")==-1 && index($line2, "XS:A")!=-1) {
	$xs = substr($line2, index($line2, "XS:A"), 6);
	print STDOUT "$line1\t$xs\n";
	print STDOUT "$line2\n";
    }
    else {
	print STDOUT "$line1\n";
	print STDOUT "$line2\n";
    }
    
    $line1 = <STDIN>;
    if (!$line1) {
	last;
    }
    chomp($line1);
}

close(STDIN);
close(STDOUT);
exit 0;

sub usage {
    print "Unknown option: @_\n" if ( @_ );
    print "Usage: perl addXS.pl --input IN [--output OUT] [--help|?] \n";
    exit 1;
}
