#!/usr/bin/env perl
#!/bin/env perl

## Name: patchisoform.pl
## Version: 1.2.1
## Date: Mar 09, 2016
## Author: Van Du Tran and Daniel Gautheret
## Maintainer: Van Du Tran and Daniel Gautheret

## patch unusual GFF format (H.sapiens)
# --input, input gff file
# --output, output gff file

use strict;
use warnings;
use Getopt::Long;

my $help;
my $input;
my $output;

my $name;
my $line;
my @args;
my @note;
my $count;

usage() if (@ARGV < 2 or
	    ! GetOptions("help|?" => \$help,
			 "input=s" => \$input,
			 "output=s" => \$output)
	    or defined $help);

if (defined $input) {
    open(STDIN, $input);
}
if (defined $output) {
    open(STDOUT, ">$output");
}

while ($line=<STDIN>) {
    @args = split("\t", $line);
    if ($args[2] eq "gene") {
	print STDOUT $line;
	$count = 0;
	@note = split("[=;]", $args[8]);
	$name = $note[1];
    }
    else {
	if ($args[2] eq "transcript") {
	    $count++;
	}
	else {
	    if ($count > 0) {
		@note = split("=", $args[8]);
		$note[-1] = $name.".".$count."\n";
		$args[8] = join("=", @note);
	    }
	    print STDOUT join("\t", @args);
	}
    }
}
close(STDIN);
close(STDOUT);
exit 0;

sub usage {
    print "Unknown option: @_\n" if ( @_ );
    print "Usage: perl patchisoform.pl --input IN [--output OUT] [--help|?] \n";
    exit 1;
}
